<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services\RelImpostoProdutoService;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;
use Zeedhi\Framework\Util\Functions;

class RelImpostoProduto  {
    protected $impostoProduto;
    protected $utilService;

    public function __construct (RelImpostoProdutoService $impostoProduto, Utilities\Util $utilService ){
        $this->utilService = $utilService;
        $this->impostoProduto = $impostoProduto;
    }
    public function getData(Request\Filter $request, Response $response) {
        $dataSourceName = 'vnd41300_vendasRealizadasporImposto';
        try{
            $conditions = $this->utilService->getParamsAsArray($request);
            
            if(empty($conditions['CDARVPRODI'])){
                unset($conditions['CDARVPRODI']);
                unset($conditions['CDARVPRODF']);
            }
            
            if(Functions::arrayKeyExists('DTENTRVENDA', $conditions)){
                if($conditions['DTENTRVENDA']){
                    if(!Functions::arrayKeyExists('CDFILIAL', $conditions)) {
                        $conditions['CDFILIAL'] = array();
                    }
                    if(!Functions::arrayKeyExists('CDCAIXA', $conditions)) {
                        $conditions['CDCAIXA'] = array();
                    }
                    if(!Functions::arrayKeyExists('CDIMPOSTO', $conditions)) {
                        $conditions['CDIMPOSTO'] = array();
                    }
                    if(!Functions::arrayKeyExists('CDARVPRODI', $conditions)) {
                        $conditions['CDARVPRODI'] = null;
                        $conditions['CDARVPRODF'] = null;
                    }
                    if(!Functions::arrayKeyExists('CDARVPRODF', $conditions)) {
                        $conditions['CDARVPRODF'] = $conditions['CDARVPRODI'];
                    }
                    if(!Functions::arrayKeyExists('DTENTRVENDA', $conditions)) {
                        $conditions['DTENTRVENDA'] = null;
                    }
                    if(Functions::arrayKeyExists('DTENTRVENDA', $conditions)) {
                        $conditions['P_DTINI'] = $conditions['DTENTRVENDA'][0];
                        $conditions['P_DTFIM'] = $conditions['DTENTRVENDA'][1];
                        unset($conditions['DTENTRVENDA']);
                    }
                    $response->addDataSet(new DataSet($dataSourceName,
                    $this->impostoProduto->buscaDados($conditions['CDFILIAL'], $conditions['P_DTINI'], $conditions["P_DTFIM"], $conditions["CDARVPRODI"], $conditions["CDARVPRODF"], $conditions["CDCAIXA"], $conditions["CDIMPOSTO"], $conditions["NRORG"], $conditions['IDRELATORIO'])));
    
                    return $response;
                }
            }
            else {
                return $response;
            }
        
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}
  